Status: Closed Start date:  
Assignee: Marius BĂLTEANU % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 5.0.8   

Resolution: Fixed Affected version:  

Description

If you type a character after `@` in issues, etc., it will auto-complete.

If the character contains `%`, an error is output to the server log.

The following patch seems to fix it.

--- a/app/assets/javascripts/application.js

+++ b/app/assets/javascripts/application.js

@@ -1167,7 +1167,7 @@ function inlineAutoComplete(element) {

             if (event.target.type === 'text' && $(element).attr('autocomplete') != 'off') {

               $(element).attr('autocomplete', 'off');

             }

-            remoteSearch(getDataSource('issues') + text, function (issues) {

+            remoteSearch(getDataSource('issues') + encodeURIComponent(text), function (issues) {

               return cb(issues);

             });

           },

@@ -1189,7 +1189,7 @@ function inlineAutoComplete(element) {

         {

           trigger: '[[',

           values: function (text, cb) {

-            remoteSearch(getDataSource('wiki_pages') + text, function (wikiPages) {

+            remoteSearch(getDataSource('wiki_pages') + encodeURIComponent(text), function (wikiPa

ges) {

               return cb(wikiPages);

             });

           },

@@ -1211,7 +1211,7 @@ function inlineAutoComplete(element) {

           values: function (text, cb) {

             const url = getDataSource('users');

             if (url) {

-              remoteSearch(url + text, function (users) {

+              remoteSearch(url + encodeURIComponent(text), function (users) {

                 return cb(users);

               });

             }

 https://github.com/redmine/redmine/blob/e8c373e5596b38e3b9434cfb0730bfb08b7d8c6d/app/assets/javascripts/application.js#L116

2-L1231

1. Error Examples

input: `@a%`

log: `ActionController::BadRequest (Invalid query parameters: invalid -encoding (a)):`

input: `#%`

log: `ActionController::BadRequest (Invalid query parameters: invalid -encoding ()):`

1. environment
https://github.com/redmine/redmine/blob/e8c373e5596b38e3b9434cfb0730bfb08b7d8c6d/app/assets/javascripts/application.js#L1162-L1231
https://github.com/redmine/redmine/blob/e8c373e5596b38e3b9434cfb0730bfb08b7d8c6d/app/assets/javascripts/application.js#L1162-L1231


$ git rev-parse --short HEAD

e8c373e55

 
$ RAILS_ENV=development bin/about

Environment:

  Redmine version                5.1.1.devel

  Ruby version                   3.1.4-p223 (2023-03-30) [x86_64-linux]

  Rails version                  7.1.3

  Environment                    development

  Database adapter               SQLite

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

Redmine settings:

  Redmine theme                  Default

SCM:

  Subversion                     1.14.2

  Mercurial                      6.3.2

  Git                            2.39.2

  Filesystem

Redmine plugins:

  no plugin installed

Associated revisions

Revision 22740 - 2024-02-26 22:32 - Marius BĂLTEANU

Fixes error in autocomplete (ActionController::BadRequest (Invalid query parameters: invalid %-encoding (%)) (#40237).

Patch by Abe Tomoaki (@abetomo).

Revision 22753 - 2024-02-27 21:12 - Marius BĂLTEANU

Backport r22740 from trunk to 5.1-stable (#40237).

Revision 22754 - 2024-02-27 21:14 - Marius BĂLTEANU

Merged r22753 from 5.1-stable to 5.0-stable (#40237).

History

#1 - 2024-02-15 07:54 - Marius BĂLTEANU

- Description updated

#2 - 2024-02-15 07:54 - Marius BĂLTEANU

- Description updated

#3 - 2024-02-15 08:50 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to Candidate for next minor release

#4 - 2024-02-26 22:30 - Marius BĂLTEANU

- Target version changed from Candidate for next minor release to 5.0.8

#5 - 2024-02-26 22:34 - Marius BĂLTEANU

- Category set to UI

- Status changed from Confirmed to Resolved

- Assignee set to Marius BĂLTEANU

- Resolution set to Fixed

Abe Tomoaki, thanks for reporting and fixing the issue, I've just committed your solution. The fix will be available in the new maintenance releases.

#6 - 2024-02-27 00:07 - Abe Tomoaki

Thanks!
https://www.redmine.org/users/691396


#7 - 2024-02-27 21:17 - Marius BĂLTEANU

- Status changed from Resolved to Closed
